Fretty
==================

Brief
---------------------------
Fretty is a 2D and 3D FRET image deconvolution plugin for ImageJ written in Java.

It comes with 2 GUI plugins for ImageJ which focus on 2D and 3D deconvolution separately. 

Fretty 2D
----------------------------
This tool is designed to calculate FRET efficiency from a series of microscope images collected with a spectral detector using a 2D spectral unmixing algorithm. This algorithm allows for bleed through of the donor emission into the acceptor emission channels to be directly accounted for improving the accuracy of the FRET calcualtion. A new image can be created in which each pixel contains the FRET efficiency value at that position, or the FRET efficiency can be calculated in a region of interest in the image. The direct excitation of the acceptor using the donor excitation wavelength can be corrected for if desired using the cross excitation function.

Fretty 3D
---------------------------
This tool is designed to calculate FRET efficiency from a series of microscope images collected with a spectral detector and a range of excitation wavelengths using a 3D spectral unmixing algorithm. This algorithm allows for bleed through of the donor emission into the acceptor emission channels and direct excitation of the acceptor with the donor excitation to be directly accounted for. The concept is similar to the 2D algorithm, except now instead of each spectrum referring to the emission spectrum collected a a particular excitation wavlength, 3D spectra are used which contain the emission intensity for a range of both excitation and emission wavelengths.

Full Documentation
------------------------------
You can view the full Fretty documentation in the file fretty_documentation.rtf